'use strict';

var _extends = require('babel-runtime/helpers/extends')['default'];

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactStaticContainer = require('react-static-container');

var _reactStaticContainer2 = _interopRequireDefault(_reactStaticContainer);

var _RouteAggregator = require('./RouteAggregator');

var _RouteAggregator2 = _interopRequireDefault(_RouteAggregator);

var _utilsGetParamsForRoute = require('./utils/getParamsForRoute');

var _utilsGetParamsForRoute2 = _interopRequireDefault(_utilsGetParamsForRoute);

var propTypes = {
  queries: _react2['default'].PropTypes.object.isRequired,
  routerProps: _react2['default'].PropTypes.object.isRequired,
  children: _react2['default'].PropTypes.node.isRequired
};

var contextTypes = {
  routeAggregator: _react2['default'].PropTypes.instanceOf(_RouteAggregator2['default']).isRequired
};

function RouteContainer(_ref, _ref2) {
  var queries = _ref.queries;
  var routerProps = _ref.routerProps;
  var children = _ref.children;

  var props = _objectWithoutProperties(_ref, ['queries', 'routerProps', 'children']);

  var routeAggregator = _ref2.routeAggregator;
  var key = routerProps.key;
  var route = routerProps.route;

  var params = _utilsGetParamsForRoute2['default'](routerProps);

  var _routeAggregator$getData = routeAggregator.getData(route, key, queries, params);

  var failure = _routeAggregator$getData.failure;
  var fragmentPointers = _routeAggregator$getData.fragmentPointers;
  var readyState = _routeAggregator$getData.readyState;

  var shouldUpdate = true;
  var element = undefined;

  // This is largely copied from RelayRootContainer#render.
  if (failure) {
    var renderFailure = route.renderFailure;

    if (renderFailure && typeof renderFailure === 'object') {
      renderFailure = renderFailure[key];
    }

    if (renderFailure) {
      var error = failure[0];
      var retry = failure[1];

      element = renderFailure(error, retry);
    } else {
      element = null;
    }
  } else if (fragmentPointers) {
    var data = _extends({}, props, params, fragmentPointers);

    var renderFetched = route.renderFetched;

    if (renderFetched && typeof renderFetched === 'object') {
      renderFetched = renderFetched[key];
    }

    if (renderFetched) {
      element = renderFetched(data, readyState);
    } else {
      element = _react2['default'].cloneElement(children, data);
    }
  } else {
    var renderLoading = route.renderLoading;

    if (renderLoading && typeof renderLoading === 'object') {
      renderLoading = renderLoading[key];
    }

    if (renderLoading) {
      element = renderLoading();
    } else {
      element = undefined;
    }

    if (element === undefined) {
      element = null;
      shouldUpdate = false;
    }
  }

  return _react2['default'].createElement(
    _reactStaticContainer2['default'],
    { shouldUpdate: shouldUpdate },
    element
  );
}

RouteContainer.propTypes = propTypes;
RouteContainer.contextTypes = contextTypes;

exports['default'] = RouteContainer;
module.exports = exports['default'];