'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _RelayRouterContext = require('./RelayRouterContext');

var _RelayRouterContext2 = _interopRequireDefault(_RelayRouterContext);

var _RouteContainer = require('./RouteContainer');

var _RouteContainer2 = _interopRequireDefault(_RouteContainer);

var _utilsGetRouteQueries = require('./utils/getRouteQueries');

var _utilsGetRouteQueries2 = _interopRequireDefault(_utilsGetRouteQueries);

exports['default'] = {
  renderRouterContext: function renderRouterContext(child, props) {
    return _react2['default'].createElement(
      _RelayRouterContext2['default'],
      props,
      child
    );
  },

  renderRouteComponent: function renderRouteComponent(child, props) {
    /* eslint-disable react/prop-types */
    var key = props.key;
    var route = props.route;

    /* eslint-enable react/prop-types */

    var routeQueries = _utilsGetRouteQueries2['default'](route, props);
    var queries = key ? routeQueries && routeQueries[key] : routeQueries;
    if (!queries) {
      return child;
    }

    return _react2['default'].createElement(
      _RouteContainer2['default'],
      { queries: queries, routerProps: props },
      child
    );
  }
};
module.exports = exports['default'];